#!/usr/local/bin/webwork-perl

## $Id: welcome.pl,v 1.5 2001/06/18 15:21:51 sam Exp $

$|++;
use lib '.'; use webworkInit; # WeBWorKInitLine
require 5.001;
use strict;

use Auth;
use Global;
use CGI qw(:standard) ;

# Timing code
use Benchmark;
my $beginTime = new Benchmark;
# end Timing code

# $cgi = new CGI_Lite();
# %inputs = $cgi->parse_form_data();
&CGI::ReadParse;
my %inputs = %main::in;

# get information from CGI inputs  (see also below for additional information)
	my $Course 		=  $inputs{'course'};
	my $User 		=  $inputs{'user'};
	my $Session_key         =  $inputs{'key'};
# establish environment for this script
	&Global::getCourseEnvironment($Course);


	my $cgiURL                  = getWebworkCgiURL();
	my $scriptDirectory         = getWebworkScriptDirectory();  #$Global::scriptDirectory;
	my $databaseDirectory       = getCourseDatabaseDirectory(); #$Global::databaseDirectory;

	require "${scriptDirectory}$Global::DBglue_pl";
	require "${scriptDirectory}$Global::classlist_DBglue_pl";
	require "${scriptDirectory}$Global::HTMLglue_pl";
	require "${scriptDirectory}$Global::FILE_pl";

	my $permissionsFile 	= &Global::getCoursePermissionsFile($Course);
	my $permissions  		= &get_permissions($User,$permissionsFile);
	my $keyFile 			= &Global::getCourseKeyFile($inputs{'course'});

# log access
	&Global::log_info('', query_string);


&verify_key($inputs{'user'}, $inputs{'key'}, "$keyFile", $inputs{'course'});
my $studentLogin=$inputs{'user'};

## If a professor was viewing a student's problem set (coming from the Prof page) and
## then hits the Problem Set button, he or she will see all the students sets.

if ((defined $inputs{'probSetKey'}) and ($permissions == $Global::instructor_permissions)) {
	attachProbSetRecord($inputs{'probSetKey'});
	$studentLogin = getStudentLogin($inputs{'probSetKey'});
}

## check that database exists
unless ( -e "${databaseDirectory}$Global::database" ) {
    wwerror($0, "No problem sets have been built yet");
}

# obtain list of setNumbers


my %setNumberHash=&getAllSetNumbersForStudentLoginHash($studentLogin);

# get one PSVN and determine the students name.
my @PSVNs = values %setNumberHash;

# this is so the correct emailaddress gets sent to feedback
$inputs{'probSetKey'}=$PSVNs[0];

attachCLRecord($studentLogin);

my $studentName=&CL_getStudentName($studentLogin);
my $currentDate = &formatDateAndTime(time);

# get information on open/due/answer dates for each problem and prepare
# HTML output;

my @SetNumberKeys =  keys(%setNumberHash);
my @problemDates = ();
my $problemDateLine;
my ($probSetKey,$odts,$ddts,$adts,$timeNow,$DueDate,$AnswerDate,$OpenDate);
my $sortedSetNumber;
my $SetNumber;
my %problemDateLines =();
my %dueTimes =();

foreach $SetNumber(@SetNumberKeys) {
    $probSetKey=$setNumberHash{$SetNumber};
    &attachProbSetRecord($probSetKey);
    $odts=&getOpenDate($probSetKey);
    $ddts=&getDueDate($probSetKey);
    $dueTimes{$SetNumber} = $ddts;
    $adts=&getAnswerDate($probSetKey);
    $timeNow = time;

    $DueDate=&formatDateAndTime($ddts);
        $AnswerDate = &formatDateAndTime($adts);
        $OpenDate =  &formatDateAndTime($odts);

# prepare message based on current time relative to the Open, Due and Answer dates.
    $problemDateLine = "";
    $problemDateLine = "<OPTION VALUE= \"$probSetKey\">";

    $problemDateLine .= "Set $SetNumber";
     ($timeNow < $odts ) &&                             # beforeOpenDateMsg
        do {$problemDateLine .= " --- Before open date -- Open date is: $OpenDate";};
        ( $odts <= $timeNow ) && ($timeNow < $ddts) &&  # afterOpenDateMsg
                do {$problemDateLine .=  " --- OPEN--  Due date is: $DueDate";};
        ( $ddts <= $timeNow ) && ($timeNow < $adts) &&  #  afterDueDateMsg
                do {$problemDateLine .=  " --- CLOSED -- Answers available on: $AnswerDate";};
        ( $adts <= $timeNow ) &&                        # afterAnsDateMsg
                do {$problemDateLine .=  " --- CLOSED --  answers available.";};


    $problemDateLines{$SetNumber} =$problemDateLine;

}

## Sort setnumbers by due date

    sub by_due_date
        {
        $timeNow = time;
        if ( ($dueTimes{$a} <= $timeNow) and ($dueTimes{$b} <= $timeNow) )
            {
            ($dueTimes{$a} <=> $dueTimes{$b})
                or
            ($a cmp $b)
            }
        elsif ( ($dueTimes{$a} > $timeNow) and ($dueTimes{$b} > $timeNow) )
            {
            ($dueTimes{$a} <=> $dueTimes{$b})
                or
            ($a cmp $b)
            }
        else
            {
            $dueTimes{$b} <=> $dueTimes{$a}
            }

        }

    my @sortedSetNumberKeys = sort by_due_date keys(%problemDateLines);

    foreach $sortedSetNumber(@sortedSetNumberKeys)
        {
        push (@problemDates, $problemDateLines{$sortedSetNumber});
        }


# begin printing the WELCOME page
print &htmlTOP("WeBWorK Welcome Page");

# print navigation buttons
print qq!
<A HREF="${cgiURL}login.pl?user=$inputs{'user'}&key=$inputs{'key'}&course=$inputs{'course'}">
<IMG SRC="${Global::upImgUrl}" align="right" BORDER=1 ALT="[Up]"></A><p>
!;

print <<"ENDOFHTML1";
<H3 ALIGN="LEFT">WeBWorK welcomes $studentName for class $inputs{'course'}.</H3>

From this page you can view and answer a problem set, download a printed version
of the entire problem set in postscript or pdf format, or view a summary
of your homework grades.  If a set is closed, you can still do the problems and
WeBWorK will tell you whether your answers are correct or incorrect, but your
answers will not be recorded.
ENDOFHTML1

my $prof_switch = '';
$prof_switch = 'multiple' if ($permissions == $Global::instructor_permissions);

# FORM for accessing the problem sets via computer
print "<form METHOD = \"POST\" action=\"$Global::welcomeAction_CGI\">";
print "<HR NOSHADE>";
print "The date is currently: <B>$currentDate </B>.";
#print "<P>Select a problem set to work on, or to print:<BR> <SELECT NAME = \"probSetKey\" SIZE = \"4\" $prof_switch>\n";
print "<P>Select a problem set to work on, or to print:<BR> <SELECT NAME = 'local_psvns' SIZE = \"4\" $prof_switch>\n";

print join("\n\n", @problemDates),"\n";  # include open/due/answer dates
                     # prepared above
print "</SELECT>\n";
print &sessionKeyInputs(\%inputs);
print "<BR>";
print "<BR><input type=\"submit\"name = \"action\" value=\"Do_problem_set\">";
print "<BR><input type=\"submit\"name = \"action\" value=\"Get_hard_copy\">";
#print " in: <INPUT TYPE=RADIO NAME=\"downloadType\" VALUE=\"ps\" CHECKED><B>PostScript</B> form&nbsp;&nbsp;";
#print "<INPUT TYPE=RADIO NAME=\"downloadType\" VALUE=\"pdf\" ><B>PDF</B> form\n";
print " in: <INPUT TYPE=RADIO NAME='downloadType' VALUE='pdf' CHECKED><B>PDF</B> form&nbsp;&nbsp;";
print "<INPUT TYPE=RADIO NAME='downloadType' VALUE='ps'><B>PostScript</B> form\n";
print "<INPUT TYPE=RADIO NAME='downloadType' VALUE='TeX'><B>TeX</B> form\n" if $permissions == $Global::instructor_permissions;
print "<INPUT TYPE=RADIO NAME='downloadType' VALUE='dvi'><B>DVI</B> form\n" if $permissions == $Global::instructor_permissions;
print "<BR>Professors can select and download multiple sets.<BR>" if $permissions == $Global::instructor_permissions;
print "<BR><INPUT TYPE=CHECKBOX NAME=\"ShowAns\" VALUE=\"1\"> Show answers in hard copy IF the answers are available.\n" ;
print "</FORM>\n ";

# FORM for viewing student summary

print "<FORM METHOD = \"POST\" action=\"${Global::cgiWebworkURL}studentSummary.pl\">\n ";
print "<HR NOSHADE>Obtain a summary of your WeBWorK scores:<BR>\n ";

## If a professor was viewing a student's problem set (coming from the Prof page) and
## then hits the Problem Set button, he or she will get the students summary
if ((defined $inputs{'probSetKey'}) and ($permissions == $Global::instructor_permissions)) {
	print qq!	<INPUT TYPE='HIDDEN' NAME='studentLogin' VALUE = $studentLogin>!;
}

print &sessionKeyInputs(\%inputs);
print "<input type=\"submit\" value=\"Get Summary\">";
print "</FORM>";



print &htmlBOTTOM("welcome.pl",\%inputs);

# begin Timing code
my $endTime = new Benchmark;
&Global::logTimingInfo($beginTime,$endTime,"welcome.pl",$inputs{'course'},$inputs{'user'});
# end Timing code
exit;




