#!/usr/local/bin/webwork-perl

## $Id: HTMLglue.pl,v 1.6 2001/07/03 16:43:47 apizer Exp $

#strings for HTML display in webwork

use lib '.'; use webworkInit; # WeBWorKInitLine
use strict;

use Global;

sub htmlTOP {
    my ($title, $bg_url, @headers) = @_;
    my $background_url = $bg_url || $Global::background_plain_url;

    my $out = <<ENDhtmlTOP;
content-type: text/html
@headers

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN" "http://www.w3.org/TR/REC-html40/strict.dtd">
<HTML>
<HEAD>
<TITLE>$title</TITLE>
</HEAD>
<BODY BACKGROUND="$background_url"><p>
<P>
<P ALIGN="CENTER"><IMG SRC="$Global::headerImgUrl" BORDER=1 ALT="WeBWorK"></P>
<P>
ENDhtmlTOP
    $out;
}

sub sessionKeyInputs {
    my($inputsref) = @_;  # Argument is a pointer to the hash %inputs
    my $out = qq!
    <INPUT TYPE="HIDDEN" NAME="course" VALUE="$$inputsref{'course'}">
    <INPUT TYPE="HIDDEN" NAME="user"  VALUE="$$inputsref{'user'}">
    <INPUT TYPE="HIDDEN" NAME="key"   VALUE="$$inputsref{'key'}">
!;

    $out;
}

sub htmlBOTTOM {
    my ($scriptName,$inputsref, $helpFile) = @_;
    my ($studentLogin, $studentID, $studentName, $studentEmail, $setNumber, $sectionName,$recitationName) = ('','','','','','','');

    my ($psvn,$probNum);
    $psvn   =  ( defined($$inputsref{'probSetKey'}) ) ? $$inputsref{'probSetKey'}: "";
    $probNum = ( defined($$inputsref{'probNum'}   ) ) ? $$inputsref{'probNum'}   : "";
    my $mode = $$inputsref{'Mode'};
    $mode = $Global::htmlModeDefault unless $mode;
    if ($psvn) {
	    attachProbSetRecord($psvn);
	    $studentLogin = getStudentLogin($psvn);
	    attachCLRecord($studentLogin);
	    
	    $studentID      = CL_getStudentID($studentLogin);
	    $studentEmail   = CL_getStudentEmailAddress($studentLogin);
	    $studentName    = CL_getStudentName($studentLogin);
	    $setNumber  = getSetNumber($psvn);
	    $setNumber  = '' unless defined($setNumber);
	    $sectionName =  CL_getClassSection($studentLogin);
	    $sectionName = '' unless defined($sectionName);
	    $recitationName =  CL_getClassRecitation($studentLogin);
	    $recitationName = '' unless defined($recitationName);
    }


    #This put in to work with the old stuff (before EmailAddress was added to DB)
#  unless (defined($studentEmail)) {
# $studentEmail = $$inputsref{'user'} . '@uhura.cc.rochester.edu';
#}

    my $out = '<HR><TABLE><TR>';

    $out .= '<TD valign="top">' . qq{
    <FORM ACTION="$Global::logout_CGI" METHOD="POST">
    <INPUT TYPE="image" SRC="$Global::logoutGifUrl"  ALT="[Logout]" Value="Logout">
        <INPUT TYPE="HIDDEN" NAME="user"   VALUE="$$inputsref{user}">
        <INPUT TYPE="HIDDEN" NAME="key"    VALUE="$$inputsref{key}">
        <INPUT TYPE="HIDDEN" NAME="course" VALUE="$$inputsref{course}">
    </FORM>
    } . '</TD>' if $$inputsref{user} && $$inputsref{key} && $$inputsref{course};

    my $To = $Global::feedbackAddress;
    $To =~ s/\s//g;
    $out .= '<TD valign="top">' . qq{
      <FORM ACTION="${Global::cgiWebworkURL}feedback.pl?$To" METHOD="POST">
      <INPUT TYPE="image" SRC="$Global::feedbackGifUrl"  ALT="[Feedback]"  VALUE="Feedback">
      <INPUT TYPE="HIDDEN" NAME="probSetKey"    VALUE="$psvn">
      <INPUT TYPE="HIDDEN" NAME="section"    VALUE="$sectionName">
      <INPUT TYPE="HIDDEN" NAME="recitation"    VALUE="$recitationName">
      <INPUT TYPE="HIDDEN" NAME="probNum" VALUE="$probNum">
      <INPUT TYPE="HIDDEN" NAME="setnum"  VALUE="$setNumber">
      <INPUT TYPE="HIDDEN" NAME="id"       VALUE="$studentID">
      <INPUT TYPE="HIDDEN" NAME="name"    VALUE="$studentName">
      <INPUT TYPE="HIDDEN" NAME="email"   VALUE="$studentEmail">
      <INPUT TYPE="HIDDEN" NAME="Mode"   VALUE="$mode">
    };

    $out .= &sessionKeyInputs($inputsref) . "</FORM> </TD>\n";

    $out .= qq{
    <TD valign="top">
    <A HREF = "${Global::helpURL}$helpFile" TARGET = 'help_page'><IMG SRC="$Global::helpGifUrl"  ALT="[Help]"></A>
    </TD>
    } if (defined $helpFile);

    $out .= qq{
    		<TD valign ="top">
			<FORM METHOD=POST ACTION=\"${Global::cgiWebworkURL}welcome.pl\"><P>
		        <INPUT TYPE="HIDDEN" NAME="user"   VALUE="$$inputsref{user}">
		        <INPUT TYPE="HIDDEN" NAME="key"    VALUE="$$inputsref{key}">
		        <INPUT TYPE="HIDDEN" NAME="course" VALUE="$$inputsref{course}">

             	<INPUT TYPE=SUBMIT VALUE="Problem Sets">
             </FORM>
             </TD>
    } unless($0 =~ /welcome.pl/) ;  # don't put this on the probSet.pl page
#	            <INPUT TYPE=HIDDEN NAME="probSetKey" VALUE="$$inputsref{probSetKey}">
#  removed the above line from 7 lines up. It's not needed and is sometimes undefined
#  giving a warning message.

	# put link to Professor's page if user is a professor

	my $User = $$inputsref{user} if defined $$inputsref{user};
	my $Course = $$inputsref{course} if defined $$inputsref{course};
	my $permissions = 0;
	if (defined $User and defined $Course) {
		my $permissionsFile = &Global::getCoursePermissionsFile($Course);
		$permissions = &get_permissions($User, $permissionsFile);
	}

	if ($permissions == $Global::instructor_permissions) {

    	$out .= qq{
    		<TD valign ="top">
			<FORM METHOD=POST ACTION=\"${Global::cgiWebworkURL}profLogin.pl\"><P>
		        <INPUT TYPE="HIDDEN" NAME="user"   VALUE="$$inputsref{user}">
		        <INPUT TYPE="HIDDEN" NAME="key"    VALUE="$$inputsref{key}">
		        <INPUT TYPE="HIDDEN" NAME="course" VALUE="$$inputsref{course}">
             	<INPUT TYPE=SUBMIT VALUE="Enter Professor's Page">
             </FORM>
             </TD>
    	};
	};
    $out .= '</TR></TABLE>';

    $out .= qq!<TT>Problem Set Version Number: $$inputsref{'probSetKey'}</TT>\n!
    if $$inputsref{'probSetKey'};

    $out .= qq{
    <BR><TT> Page produced by script: $scriptName</TT>


    } if $scriptName;
    $out .= qq{<H4> Compiler warnings:</H4>$Global::WARNINGS} if $Global::WARNINGS;
    $out .= '</body></html>';
}

sub html_NO_PERMISSION {
    my $out = &htmlTOP;
    $out .=qq~
    <H1> NO PERMISSION </H1>
        Sorry, you do not have permission to use this script!
    ~;
    $out .= &htmlBOTTOM;
    $out;
    }
1;
