#!/usr/local/bin/webwork-perl

## $Id: columnPrint.pl,v 1.6 2001/06/25 18:20:05 sam Exp $

BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine
use Global;

# This file is   columnPrint.pl  Note: warning messages given by -w switch can safely be ignored AKP 8/20/96  

# Call with command arguments of the form:   inputFile outputFile
 

if (@ARGV != 2)
  {print "\nSyntax is columnPrint.pl inputFile.ext outputFile.ext \n";
   print "      (e.g. columnPrint.pl 140atotal.csv 140atotal.csv ) \n\n";
   exit(0);
  }
# Takes two command line arguments. 
# The first is the full file name of the
# delimited input file.  The second is the full file name of the
# output file (these names may be the same).

# This script takes any delimited (with \$DELIM delimiters) file and adds
# extra space if necessary to the fields so that all columns line up.
# The widest field in any column will contain exactly 2 spaces at the
# end of the (non space characters 0f the) field. For example
# ",a very long field entry  ," at one extreme and  ",  ," at the other
# assuming that \$DELIM = ","  .


local($fileName1,$fileName2) = @ARGV;

$scriptDirectory   = $Global::scriptDirectory;
require "${scriptDirectory}$Global::FILE_pl";

&columnPrint ($fileName1,$fileName2);
