#!/usr/local/bin/webwork-perl


BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine
use Global;


# This file is deleteColumns.pl   

	
    ## Takes four command line arguments.
	## The first is the course name.
	## The second is the filename (without the extension),
    ## the third is the first column of a range ofcolumns to delete,
    ## the fourth is the last column of a range ofcolumns to delete,
	## e.g. deleteLastColumns.pl className  s5ful 14 24   or  deleteLastColumns.pl className  s5scr 9 13.
        ## Note that "ful" files contain 2 columns for each problem (a `#corr' and an `#incorr'
        ## column) where as "scr" files contain 1 column for each problem (a `score' column).


#require "webwork.ph";
#require "${scriptDirectory}$DBglue_pl";
#require "${scriptDirectory}$SCRtools_pl";
#require "${scriptDirectory}FILE.pl";

if (@ARGV != 4)
  {print "\nSyntax is deleteColumns.pl courseID dataSetFile firstColumn lastColumn \n";
   print "File names are entered with or without the extension, e.g. enter s7scr or s7scr.csv \n";
   print "      (e.g. deleteColumns.pl MTH140A s7scr 10 15   or\n";
   print "            deleteColumns.pl MTH140A s7scr -6 -1 ) \n\n";
   exit(0);
  }

local($courseID, $fileName1,$num1, $num2)=@ARGV; 

$scriptDirectory   = $Global::scriptDirectory;
&Global::getCourseEnvironment($courseID);

require "${scriptDirectory}$Global::DBglue_pl";
require "${scriptDirectory}$Global::FILE_pl";
require "${scriptDirectory}$Global::SCRtools_pl"; 

$fileName1 =~ s/\.$Global::dat$//;  ## remove dat extension if present



&delete_columns ($fileName1,$num1, $num2,1);
