#!/usr/local/bin/webwork-perl


BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine

use Global;
use Auth;
use strict;

if (@ARGV != 2)
  {
   print "\nSyntax is export_permission-database.pl courseID outputTextFile\n";
   print "      (e.g. export_permission-database.pl  demoCourse textDatabase)\n\n";
   exit(0);
  }

my $course = $ARGV[0];
my $outFileName = $ARGV[1];

# establish environment for this script

&Global::getCourseEnvironment($course);

# File names

my $perm_file = &Global::getCoursePermissionsFile($course);

my %perm_hash;
my $perm_obj;

&Global::tie_hash('PERM_FILE',\$perm_obj,\%perm_hash, $perm_file,'R',$Global::standard_tie_permission);
 
my ($key,$item);
my @keys = sort keys %perm_hash;

open(OUTFILE,">$outFileName") or wwerror("$0","can't open $outFileName for writing");

foreach $key (@keys) {
    print OUTFILE "[$key]\n";
    print OUTFILE "\t$perm_hash{$key}\n";
}

close(OUTFILE);
&Global::untie_hash('PERM_FILE',\$perm_obj,\%perm_hash, $perm_file);
