#!/usr/local/bin/webwork-perl

####################################################################
# Copyright @ 1995-1998 University of Rochester
# All Rights Reserved
####################################################################



use GDBM_File;

my $TieMaxTries =30;	# try to tie() 30 times, then fail
my $TieSleepInterval =2; # sleep 2 sec after failed tie()
 
sub tie_hash {
    my($fileHandle, $db_obj_ref, $hash_ref, $file_name, $mode_flag, $permission) = @_;

    ## try to achieve tie $Max_Tries times, with a wait of $Sleep_interval
    ## between attempts.
    
    ## \$fileHandle and \$db_obj_ref are not used for gdbm databases

    my ($tries, $mode);
    if (($mode_flag eq 'W') or ($mode_flag eq 'w')) {$mode = &GDBM_WRCREAT();} else {$mode = &GDBM_READER();}	
    for ($tries = 0; $tries < $TieMaxTries; $tries++) {
       	my $success_flag = tie(%$hash_ref, 'GDBM_File', $file_name, $mode, $permission);
    	$Global::DBtie_tries += $tries + 1 if $success_flag;
		return 1 if $success_flag;
		sleep($TieSleepInterval);
    }
    &Global::error("Key database error", "Can't tie $file_name: $!");
}
sub untie_hash {
    my($fileHandle,$DbObj_ref,$hash_ref,$file_name) = @_;
        
    untie(%$hash_ref) || &Global::error("WeBWorK database error", "Can't untie database $file_name at");
    1;              # Explicitly return 1 if successful
}

1;  ## script must return a true value



