#!/usr/local/bin/webwork-perl

## $Id: newpassword.pl,v 1.6 2001/06/25 18:20:05 sam Exp $

## newpassword.pl takes as arguments the course, loginname and newpassword
##	e.g. newpassword.pl demoCourse dummy 000-00-0000

## NOTE: this should only be run by the professor

BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine
use Global;
use Auth;

$course      = $ARGV[0];
$login_name  = $ARGV[1];
$newPassword = $ARGV[2];

if(@ARGV != 3)
  {print "\nSyntax is: newpassword.pl coursename loginname newpassword\n";
   print "     (e.g. newpassword.pl demoCourse aa001c 3ldI9y)\n\n";
   exit(0);
  }
&Global::getCourseEnvironment($course);
my $passwordFile = &Global::getCoursePasswordFile($course);
my $permissionsFile = &Global::getCoursePermissionsFile($course);

print "$login_name, $newPassword, $passwordFile\n";

&new_password($login_name, $newPassword, $passwordFile);
unless (defined &get_permissions($login_name, $permissionsFile))
  { &put_permissions(0,$login_name,$permissionsFile);}

# leave permissions as the originally were. Now if someone in the group runs this
#script, they will not get an error message 

#chmod($Global::password_permission, $passwordFile) ||
#                             die "Can't do chmod($Global::password_permission, $passwordFile)";
#chown(-1,$Global::numericalGroupID,$passwordFile)  ||
#                             die "Can't do chown(-1,$Global::numericalGroupID,$passwordFile)";
#
#chmod($Global::permissions_permission, $permissionsFile) ||
#                             die "Can't do chmod($Global::permissions_permission, $permissionsFile)";
#chown(-1,$Global::numericalGroupID,$permissionsFile)  ||
#                             die "Can't do chown(-1,$Global::numericalGroupID,$permissionsFile)";



