#!/usr/local/bin/webwork-perl


# This file is buildProbSetDBfromPSVNlog.pl
# Call with command arguments of the form:  classID set5.def  classlist.lst psvnlogfile
# This file loads the database from the class list and the set definition
# copyright 1996  WeBWorK  All rights reserved.
###################################################################

BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine

use Global;
use Auth;
use TimeLocal;


#       Seed random number generator

srand();

# Check that this program was called with four arguments
if (@ARGV != 3 )
        { print "\nsyntax: rebuildProbSetDBromPSVNlog.pl  courseID set4.def psvnLogFileName\n";
		  print "\nThe psvnLogFiles are located in courseID/logs/\n\n";
		  
		  print "E.g. rebuildProbSetDBfromPSVNlog.pl MTH140A set4.def  MTH140A_set:4_bak1.psvnlog\n\n";
          exit (0);
        }
else 	{
		$classID = $ARGV[0];
     	$setDefFilename = $ARGV[1];
#        $classlistFilename = $ARGV[2];
		$logFileName = $ARGV[2];
		}

### $method ='readFromLogFile' or 'createNewPSVNs'
#$logFileName = "sampleCourse_set:3_bak3.psvnlog";

$method = 'readFromLogFile';


$scriptDirectory   = $Global::scriptDirectory;
require "${scriptDirectory}$Global::buildProbSetTools";

#my $message = &buildProbSetDB($classID,$setDefFilename,$classlistFilename,$method,$logFileName);
my $message = &buildProbSetDB($classID,$setDefFilename,$method,$logFileName);
print $message;
