#!/usr/local/bin/webwork-perl

## $Id: removeProfPermissions.pl,v 1.6 2001/06/25 18:20:05 sam Exp $

# ##################################################################
# Copyright @ 1995-1998 University of Rochester
# All Rights Reserved
# ##################################################################

BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine

## removeProfPermissions.pl takes as arguments the coursename and instructors login_name
##	e.g. removeProfPermissions.pl demoCourse jsmith

## NOTE: this should only be run by the professor

use Global;
use Auth;
use strict;


if(@ARGV != 2) {
    print "\nSyntax is removeProfPermissions.pl coursename instructorLoginName\n";
    print "      (e.g. removeProfPermissions.pl demoCourse jsmith)\n\n";
    exit(0);
}

my $course = $ARGV[0];
my $user = $ARGV[1];


&Global::getCourseEnvironment($course);

my $permissionsFile = &Global::getCoursePermissionsFile($course);
my $scriptDirectory = &Global::getWebworkScriptDirectory($course);  

require "${scriptDirectory}$Global::FILE_pl";

if (  defined( &get_permissions($user,$permissionsFile) ) ) {
    if ( &put_permissions(0,$user,$permissionsFile) ) {
        print "Instructor permissions removed for $user\n\n";
    }
    else {
    print "removeProfPermissions.pl: Unable to remove permissions for $user\n\n";
    }
}
else {
	print "User $user is not listed in the permissions file\n";
	print "Cannot remove instructor permissions for $user\n\n";
}

print "Printout of permissions file\n";
my %perm_hash =get_hash_from_db($permissionsFile);
my(@permKeys) = sort keys %perm_hash;
my $key;
foreach $key (@permKeys) {
	print "login = $key       permissions =  $perm_hash{$key}\n";
}

