#!/usr/local/bin/webwork-perl

use sigtrap;

BEGIN {
	my $useLibDir = '.';
	if    ($0 =~ m|^(/.*)/|)  { $useLibDir = $1; }
	elsif ($0 =~ m|^(\..*)/|) { $useLibDir = $1; }
	elsif ($0 =~ m|^(.+)/|)   { $useLibDir = "./$1"; }
	unshift @INC, $useLibDir;
}

use webworkInit; # WeBWorKInitLine
use Global;

BEGIN {
$SIG{__WARN__}= sub {};
}


require 5.000;


require "$Global::scriptDirectory$Global::FILE_pl";

if (@ARGV != 2) {
	print "\nSyntax is update_classlist_from_8_to_9_fields.pl in_file out_file\n";
	print "      (e.g. update_classlist_from_8_to_9_fields.pl mth101.lst mth101.lst)\n\n";
	exit(0);
}

my ($infile, $outfile) = @ARGV;
my $length;

open (INFILE, "$infile") || die "can't open $infile: $!\n";
my @classList = <INFILE>;
close(INFILE);

my $outstring = '';
my $line;

foreach $line (@classList) {
    unless ($line =~ /\S/)  {next;}
    chomp $line;
    @classListRecord=&getRecord($line);

    $length = @classListRecord;

    unless ($length == 8) {
    	my $string = join(',',@classListRecord);
    	print "\n\n        The record \n
    	$string\n
    	in the file $infile contains $length items.\n
    	All records must contain 8 items in order to run the update script.\n\n";
    	exit;
	}
    my ($studentID, $lastName, $firstName, $status, $comment, $section, $email_address, $login_name)
       = @classListRecord;
	my $recitation = '';
    my @classArray=($studentID, $lastName, $firstName, $status, $comment,  $section, $recitation, $email_address, $login_name);

  ## and print that sucker!
	$line = join("$Global::delim", @classArray);
    $outstring .= "${line}\n";
}

open (OUTFILE, ">$outfile") || die "can't open $outfile: $!\n";
print OUTFILE $outstring;
close(OUTFILE);

  ## arrange the columns nicely

&columnPrint("$outfile","$outfile");



